/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: kernel_debug.h,v 1.6 2003/11/12 08:36:18 monaka Exp $
 */

/*
 *	ITRON4.0 ǥХåѥ󥯥롼ɥե
 *
 *  ΥեϡITRON4.0ͤΥɥץե볰ȡ
 *  ITRONǥХå󥰥󥿥եͤ˴ޤޤǡJSP
 *  ΥǥХåݡȵǽɬפޤࡥ
 */

#ifndef _KERNEL_DEBUG_H_
#define _KERNEL_DEBUG_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ֥ITRONǥХå󥰥󥿥ե͡
 */
#define OBJ_SEMAPHORE		(128)
#define OBJ_EVENTFLAG		(129)
#define OBJ_DATAQUEUE		(130)
#define OBJ_MAILBOX		(131)
#define OBJ_MUTEX		(132)
#define OBJ_MESSAGEBUFFER	(133)
#define OBJ_RENDEZVOUSPORT	(135)
#define OBJ_RENDEZVOUS		(136)
#define OBJ_FMEMPOOL		(137)
#define OBJ_VMEMPOOL		(138)
#define OBJ_TASK		(139)
#define OBJ_READYQUEUE		(141)
#define OBJ_TIMERQUEUE		(142)
#define OBJ_CYCLICHANDLER	(144)
#define OBJ_ALARMHANDLER	(145)
#define OBJ_OVERRUNHANDLER	(146)
#define OBJ_ISR			(147)
#define OBJ_KERNELSTATUS	(148)
#define OBJ_TASKEXCEPTION	(149)
#define OBJ_CPUEXCEPTION	(150)

#define TTW_SLP		0x0001u		/* Ԥ */
#define TTW_DLY		0x0002u		/* ַвԤ */
#define TTW_SEM		0x0004u		/* ޥե񸻤γԤ */
#define TTW_FLG		0x0008u		/* ٥ȥե饰Ԥ */
#define TTW_SDTQ	0x0010u		/* ǡ塼ؤԤ */
#define TTW_RDTQ	0x0020u		/* ǡ塼μԤ */
#define TTW_MBX		0x0040u		/* ᡼ܥåμԤ */
#define TTW_MTX		0x0080u		/* ߥ塼ƥåΥåԤ */
#define TTW_SMBF	0x0100u		/* åХåեؤԤ */
#define TTW_RMBF	0x0200u		/* åХåեμԤ */
#define TTW_CAL		0x0400u		/* ǥ֤θƽФԤ */
#define TTW_ACP		0x0800u		/* ǥ֤μԤ */
#define TTW_RDV		0x1000u		/* ǥ֤νλԤ */
#define TTW_MPF		0x2000u		/* Ĺ֥åγԤ */
#define TTW_MPL		0x4000u		/* Ĺ֥åγԤ */

/*
 *  ǽɤ
 */
#include "fncd.h"

#ifdef __cplusplus
}
#endif

#endif /* _KERNEL_DEBUG_H_ */
