/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: configuration.c,v 1.5 2003/11/11 08:20:40 monaka Exp $
 */

/*
 *	ĥӥǽ
 */

#include "jsp_kernel.h"
#include "configuration.h"

/*
 *  CPU㳰ϥɥ
 */
#ifdef __def_exc

SYSCALL
ER def_exc(EXCNO excno, const T_DEXC *pk_dexc)
{
	if (pk_dexc == NULL) {
		undef_exc(excno);
	} else {
		define_exc(excno, pk_dexc->exchdr);
	}

	return E_OK;
}

#endif /* __def_exc */

/*
 *  ե졼λ
 *
 * pk_rcfgȤϼ¸
 * ܥСǤϡpk_rcfg ϶
 * äơ⤹뤳Ȥʤ
 */
#ifdef __ref_cfg

SYSCALL
ER ref_cfg(T_RCFG *pk_rcfg)
{
	return E_OK;
}
#endif /* __ref_cfg */

/*
 *  Сλ
 */
#ifdef __ref_ver

SYSCALL
ER ref_ver(T_RVER *pk_rver)
{
	pk_rver->maker = TKERNEL_MAKER;
	pk_rver->prid = TKERNEL_PRID;
	pk_rver->spver = TKERNEL_SPVER;
	pk_rver->pver = TKERNEL_PRVER;

	/*
	 *  prno Ƥϥ᡼ǤƤ롣
	 *  衢ιܤȤ褦ˤʤä
	 *  𤷤ʤ褦ܥСǤ
	 *  0ꥢ롣
	 */
	pk_rver->prno[0] = 0;
	pk_rver->prno[1] = 0;
	pk_rver->prno[2] = 0;
	pk_rver->prno[3] = 0;

	return E_OK;
}

#endif /* __ref_ver */


