/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: jsp_kernel.h,v 1.13 2003/11/11 05:22:19 monaka Exp $
 */

/*
 *	JSPͥ ɸ।󥯥롼ɥե
 *
 *  Υ󥯥롼ɥեϡͥץΥե
 *  ɬ󥯥롼ɤ٤ɸ।󥯥롼ɥեǤ롥
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY 
 *  ȤǡޥʳεҤȤǤ롥
 */

#ifndef _JSP_KERNEL_H_
#define _JSP_KERNEL_H_

/*
 *  ͥ̾Υ͡
 */
#include "jsp_rename.h"

/*
 *  ץꥱȶ̤Υ󥯥롼ɥե
 */
#include <kernel.h>

/*
 *  åȰ¸
 */
#include <t_config.h>

/*
 *
 */
/* #include "bufmgr.h" */

/*
 *  ֥IDκǾͤ
 */
#define	TMIN_TSKID	1	/* IDκǾ */
#define	TMIN_SEMID	1	/* ޥեIDκǾ */
#define	TMIN_FLGID	1	/* ե饰IDκǾ */
#define	TMIN_DTQID	1	/* ǡ塼IDκǾ */
#define	TMIN_MBXID	1	/* ᡼ܥåIDκǾ */
#define	TMIN_MPFID	1	/* ĹסIDκǾ */
#define	TMIN_MPLID	1	/* ĹסIDκǾ */
#define TMIN_MTXID	1	/* ߥ塼ƥåIDκǾ */
#define TMIN_MBFID	1	/* åХåեIDκǾ */
#define TMIN_PORID	1	/* ǥץݡIDκǾ */
#define	TMIN_CYCID	1	/* ϥɥIDκǾ */
#define	TMIN_ALMID	1	/* 顼ϥɥIDκǾ */
#define	TMIN_ISRID	1	/* ߥӥ롼IDκǾ */

/* 
 * ͥ٤ʳ
 */
#define	TNUM_TPRI	(TMAX_TPRI - TMIN_TPRI + 1)
#define	TNUM_MPRI	(TMAX_MPRI - TMIN_MPRI + 1)

/*
 *  ͥѤޥ
 */
#define SYSCALL

/*
 *  إåեʤ⥸塼δؿѿ
 */
#ifndef _MACRO_ONLY

/*
 *  ƥ⥸塼νkernel_cfg.c
 */
extern void	object_initialize(void);

/*
 *  롼μ¹ԡkernel_cfg.c
 */
extern void	call_inirtn(void);

/*
 *  λ롼μ¹ԡkernel_cfg.c
 */
extern void	call_terrtn(void);

/*
 *  ưåɽbanner.c
 */
extern void	print_banner(void);

/*
 *  ͥνλstartup.c
 */
extern void	kernel_exit(void);

/*
 *  ͥư֥ե饰startup.c
 */
extern BOOL	iniflg;

/*
 *  ֥
 *
 *  xxxcb.exist ξ֤򼨤
 *  exist BOOLˤ뤳Ȥǽcre_/acre_ӥ
 *  ΥХإåɤ礭ǽʸ¤߶ػ߶֤򸺤餷
 *  ǡKOBJ_EXIST̤ϿKOBJ_NOEXS ˲äơ
 *  KOBJ_INITD 
 *  KOBJ_INITD ξ֤Ǥϡcre_/acre_ӥˤäƽ
 *  Ǥ뤬߶ػ߶֤γˤ롣ӥǤID
 *  åǤE_ID顼֤ʤΤKOBJ_EXISTξ֤ΤߤǤ롣
 */
#define KOBJ_EXIST		(2)
#define KOBJ_INIT		(1)
#define KOBJ_NOEXS		(0)

#endif /* _MACRO_ONLY */
#endif /* _JSP_KERNEL_H_ */
