/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mailbox.h,v 1.12 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	᡼ܥåǽ
 */

#ifndef _MAILBOX_H_
#define _MAILBOX_H_

#include "queue.h"

/*
 *  ᡼ܥå֥å
 */
typedef struct mailbox_initialization_block {
	ATR	mbxatr;		/* ᡼ܥå° */
	PRI	maxmpri;	/* åͥ٤κ */
	VP	mprihd;
} MBXINIB;

/*
 *  ᡼ܥå֥åϢۥڥ
 */
typedef struct mailbox_initialization_block_apair {
	ID	mbxid;
	MBXINIB	mbxinib;
} MBXINIA;

/*
 *  ᡼ܥå֥å
 *
 *  å塼åͥٽξˤϡlast ϻȤʤ
 */
typedef struct mailbox_control_block {
	QUEUE	wait_queue;	/* ᡼ܥåԤ塼 */
	MBXINIB *mbxinib;	/* ᡼ܥå֥åؤΥݥ */
	T_MSG	*head;		/* ƬΥå */
	T_MSG	*last;		/* Υå */
	unsigned int	exist:2;	/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} MBXCB;

/*
 *  ᡼ܥåǽν
 */
extern void	mailbox_initialize(void);

#define MBXID(mbxcb)	((ID)((mbxcb) - mbxcb_table) + TMIN_MBXID)

#endif /* _MAILBOX_H_ */
