/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mempfix.c,v 1.28 2003/11/17 14:42:35 monaka Exp $
 */

/*
 *	Ĺס뵡ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mempfix.h"
#include "bufmgr.h"

/*
 *  ĹסIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mpfid;

/*
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern MPFINIB	mpfinib_table[];

/*
 *  Ĺס֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_mpfinia;

/*
 *  Ĺס֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const MPFINIA	mpfinia_table[];

/*
 *  ĹסͽIDΥꥢkernel_cfg.c
 */
extern const ID		mpfrid_table[];

/*
 *  ĹסͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_mpfrid;

/*
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern MPFCB	mpfcb_table[];

/*
 *  Ĺסο
 */
#define TNUM_MPF	((UINT)(tmax_mpfid - TMIN_MPFID + 1))

/*
 *  ĹסIDĹס֥åФ
 *  Υޥ
 */
#define INDEX_MPF(mpfid)	((UINT)((mpfid) - TMIN_MPFID))
#define get_mpfcb(mpfid)	(&(mpfcb_table[INDEX_MPF(mpfid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE mpf_freelist;

/*
 *  ĹסԤ֥å
 */
typedef struct fixed_memorypool_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
	VP	blk;		/* ֥å */
} WINFO_MPF;

/* 
 *  Ĺס뵡ǽν
 */
#ifdef __mpfini

QUEUE mpf_freelist;

void
mempfix_initialize()
{
	UINT	i;
	MPFCB	*mpfcb;
	MPFINIB *mpfinib;
	const MPFINIA *mpfinia;
	const ID	*mpfrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	queue_initialize(&mpf_freelist);

	/*
	 * mpfinia ˤäƼΤޤ
	 */
	for (mpfinia = mpfinia_table, i = 0; i < tnum_mpfinia; mpfinia++, i++) {
		mpfinib = &mpfinib_table[mpfinia->mpfid - TMIN_MPFID];
		*mpfinib = mpfinia->mpfinib;
		mpfcb = &mpfcb_table[mpfinia->mpfid - TMIN_MPFID];
		mpfcb->mpfinib = mpfinib;
		mpfcb->exist = KOBJ_EXIST;
		mpfcb->reserved = TRUE;

		/*
		 *  ɸcfgȤäȤmpfNULLˤʤǽ롣<BTS:21>
		 *  Τ褦cfgǤϸڹܤ롣ɸcfgǤϤΥɤ
		 *  뤳ȤϤʤ
		 */
		if (mpfinib->mpf == NULL) {
			BOOL stat;
			mpfinib->limit = mpfinib->mpf + mpfinib->blksz;
			bufmgr_allocate(&stat, mpfinib->blksz, &(mpfinib->mpf));
			assert(stat);
		}

		mpfcb->unused = mpfinib->mpf;
		mpfcb->freelist = NULL;
	}

	/*
	 *  ͽID
	 */
	for (mpfrid = mpfrid_table, i = 0; i < tnum_mpfrid; mpfrid++, i++) {
		mpfcb_table[*mpfrid - TMIN_MPFID].reserved = TRUE;
	}

	/*
	 * mpfinia ˤäƼʤΤ
	 */
	for (mpfcb = mpfcb_table, i = 0; i < TNUM_MPF; mpfcb++, i++) {
		if (mpfcb->mpfinib == NULL) {
			mpfcb->exist = KOBJ_NOEXS;
			mpfcb->mpfinib = &mpfinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mpfcb)) {
				queue_insert_prev(&mpf_freelist, (QUEUE*)mpfcb);
			} else {
				queue_initialize(&(mpfcb->wait_queue));
			}
		} else {
			queue_initialize(&(mpfcb->wait_queue));
		}
	}
}

#endif /* __mpfini */

/*
 *  Ĺס뤫֥å
 */
#ifdef __mpfget

BOOL
mempfix_get_block(MPFCB *mpfcb, VP *p_blk)
{
	FREEL	*free;

	if (mpfcb->freelist != NULL) {
		free = mpfcb->freelist;
		mpfcb->freelist = free->next;
		*p_blk = (VP) free;
		return(TRUE);
	}
	else if (mpfcb->unused < mpfcb->mpfinib->limit) {
		*p_blk = mpfcb->unused;
		mpfcb->unused = (VP)((SIZE)(mpfcb->unused)
						+ mpfcb->mpfinib->blksz);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __mpfget */

/*
 *  Ĺסζ֥å롣
 */
#ifdef __mpfcnt

UINT
mempfix_count_free(MPFCB *mpfcb)
{
	FREEL	*free;
	UINT count = 0;
	free = mpfcb->freelist;
	while(free != NULL) {
		free = free->next;
		++count;
	}

	return count;
}

#endif /* __mpfcnt */

/*
 *  Ĺס륳ȥ֥åν
 */
#ifdef __mpfcbini

ER
init_mpfcb(MPFCB *mpfcb, T_CMPF *pk_cmpf)
{
	MPFINIB *mpfinib;
	VP mpf;
	UINT blksz;
	UINT blkcnt;

	mpfinib = mpfcb->mpfinib;
	mpf = pk_cmpf->mpf;
	blksz = TROUND_VP(pk_cmpf->blksz);
	blkcnt = pk_cmpf->blkcnt;

	if (mpf == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, blksz * blkcnt, &mpf);
		if (!stat) {
			return E_NOMEM;
		}
	}
	/*
	 * Ԥ
	 */
	queue_initialize((QUEUE *)mpfcb);
	mpfinib = mpfcb->mpfinib;
	mpfinib->mpfatr = pk_cmpf->mpfatr;
	mpfinib->blksz = blksz;
	mpfinib->mpf = mpf;
	mpfinib->limit = mpf + blksz * blkcnt;

	mpfcb->unused = mpf;
	mpfcb->freelist = NULL;

	return E_OK;
}

#endif /* __mpfcbini */

/*
 *  Ĺס
 */
#ifdef __cre_mpf

SYSCALL ER
cre_mpf(ID mpfid, const T_CMPF *pk_cmpf)
{	
	MPFCB	*mpfcb;
	MPFINIB *mpfinib;
	ER	ercd;
    
	LOG_CRE_MPF_ENTER(mpfid);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);
	CHECK_OBJECT_CREATABLE(mpfcb);
	UPDATE_OBJECT_FREELIST(mpfcb);

	ercd = init_mpfcb(mpfcb, pk_cmpf);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mpfcb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_MPF_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  Ĺס(IDֹ漫ưդ
 */
#ifdef __acre_mpf

SYSCALL ER_ID
acre_mpf(const T_CMPF *pk_cmpf)
{
static MPFCB	*mpfcb = NULL;
	ER_ID	ercd;

	LOG_ACRE_MPF_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	mpfcb = (MPFCB *)t_get_free_id((QUEUE *)&mpf_freelist);
	if (mpfcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mpfcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	ercd = init_mpfcb(mpfcb, pk_cmpf);
	if (ercd == E_OK) {
		ercd = MPFID(mpfcb);
	}

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mpfcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MPF_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  Ĺסκ
 */
#ifdef __del_mpf
SYSCALL ER
del_mpf(ID mpfid)
{
	MPFCB	*mpfcb;
	TCB	*tcb;
	ER	ercd;
	BOOL	stat;

	LOG_DEL_MPF_ENTER(mpfid);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	CHECK_OBJECT_DELETABLE(mpfcb);

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(mpfcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mpfcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}
	  
	/* סΰ롣*/
	stat = bufmgr_release(mpfcb->mpfinib->mpf);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}

	if (!CHECK_OBJECT_RESERVED(mpfcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&mpf_freelist, (QUEUE *)mpfcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	mpfcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mpf */

/*
 *  Ĺ֥åγ
 */
#ifdef __get_mpf

SYSCALL ER
get_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*mpfcb;
	WINFO_MPF winfo;
	ER	ercd;

	LOG_GET_MPF_ENTER(mpfid, p_blk);
	CHECK_DISPATCH();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else {
		wobj_make_wait((WOBJCB *) mpfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_GET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __get_mpf */

/*
 *  Ĺ֥åγʥݡ󥰡
 */
#ifdef __pget_mpf

SYSCALL ER
pget_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*mpfcb;
	ER	ercd;

	LOG_PGET_MPF_ENTER(mpfid, p_blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_PGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __pget_mpf */

/*
 *  Ĺ֥åγʥॢȤ
 */
#ifdef __tget_mpf

SYSCALL ER
tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
{
	MPFCB	*mpfcb;
	WINFO_MPF winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TGET_MPF_ENTER(mpfid, p_blk, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		wobj_make_wait_tmout((WOBJCB *) mpfcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_TGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __tget_mpf */

/*
 *  Ĺ֥åֵ
 */
#ifdef __rel_mpf

SYSCALL ER
rel_mpf(ID mpfid, VP blk)
{
	MPFCB	*mpfcb;
	TCB	*tcb;
	FREEL	*free;
	ER	ercd;
    
	LOG_REL_MPF_ENTER(mpfid, blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	CHECK_PAR(mpfcb->mpfinib->mpf <= blk
			&& blk < mpfcb->mpfinib->limit
			&& ((SIZE)(blk) - (SIZE)(mpfcb->mpfinib->mpf))
					% mpfcb->mpfinib->blksz == 0);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (!(queue_empty(&(mpfcb->wait_queue)))) {
		tcb = (TCB *) queue_delete_next(&(mpfcb->wait_queue));
		((WINFO_MPF *)(tcb->winfo))->blk = blk;
		if (wait_complete(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else {
		free = (FREEL *) blk;
		free->next = mpfcb->freelist;
		mpfcb->freelist = free;
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_REL_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __rel_mpf */


/*
 *  Ĺ֥åξֻ
 */
#ifdef __ref_mpf

SYSCALL ER
ref_mpf(ID mpfid, T_RMPF *pk_rmpf)
{
	MPFCB	*mpfcb;
	FREEL	*free;
	ER	ercd;
    
	LOG_REF_MPF_ENTER(mpfid);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (!(queue_empty(&(mpfcb->wait_queue)))) {
		TCB	*tcb;
		tcb = (TCB *)queue_peek_next(&(mpfcb->wait_queue));
		pk_rmpf->wtskid = TSKID(tcb);
	}
	else {
		pk_rmpf->wtskid = TSK_NONE;
	}
	pk_rmpf->fblkcnt = mempfix_count_free(mpfcb);

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mpf */


