/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mempfix.h,v 1.12 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	Ĺס뵡ǽ
 */

#ifndef _MEMPFIX_H_
#define _MEMPFIX_H_

#include "queue.h"

/*
 *  Ĺס֥å
 */
typedef struct fixed_memorypool_initialization_block {
	ATR	mpfatr;		/* Ĺס° */
	UINT	blksz;		/* ֥åΥʴݤ᤿͡ */
	VP	mpf;		/* ĹסΰƬ */
	VP	limit;		/* Ĺסΰξ */
} MPFINIB;

/*
 *  Ĺס֥åϢۥڥ
 */
typedef struct fixed_memorypool_initialization_block_apair {
	ID	mpfid;
	MPFINIB	mpfinib;
} MPFINIA;

/*
 *  ֥åꥹȤ
 */
typedef struct free_list {
	struct free_list *next;
} FREEL;

/*
 *  Ĺס֥å
 */
typedef struct fixed_memorypool_control_block {
	QUEUE	wait_queue;	/* ĹסԤ塼 */
	MPFINIB *mpfinib;	/* Ĺס֥å */
	FREEL	*freelist;	/* ֥åΥꥹ */
	VP	unused;		/* ̤ΰƬ */
	unsigned int	exist:2;	/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} MPFCB;

/*
 *  Ĺס뵡ǽν
 */
extern void	mempfix_initialize(void);

/*
 *  Ĺס뤫֥å
 */
extern BOOL	mempfix_get_block(MPFCB *mpfcb, VP *p_blk);

/*
 *  ֥å롣
 */
extern UINT	mempfix_count_free(MPFCB *mpfcb);

#define MPFID(mpfcb)	((ID)((mpfcb) - mpfcb_table) + TMIN_MPFID)

#endif /* _MEMPFIX_H_ */
