/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Masaki Muranaka
 *  Copyright (C) 2003 by Monami-software, JAPAN 
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mempvar.h,v 1.12 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *  Ĺסǽ
 */

#ifndef __MEMPVAR_H__
#define __MEMPVAR_H__

#include "queue.h"
#include "kmem.h"

/*
 *  Ĺס֥å
 */
typedef struct mempvar_initialization_block {
  ATR mplatr;	/* Ĺס° */
  SIZE mplsz;	/* ĹסΰΥʥХȿ */
  VP mpl;
} MPLINIB;

/*
 *  Ĺס֥åϢۥڥ
 */
typedef struct mempvar_initialization_block_apair {
	ID	mplid;
	MPLINIB	mplinib;
} MPLINIA;

/*
 *  Ĺס֥å
 */
typedef struct mempvar_control_block {
	QUEUE wait_queue;
	MPLINIB *mplinib;	/* Ĺס֥å */
	KMEMB *free_list;
	unsigned int	exist:2;	/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} MPLCB;

/*
 *  Ĺס뵡ǽν
 */
extern void	mempvar_initialize(void);

#define MPLID(mplcb)	((ID)((mplcb) - mplcb_table) + TMIN_MPLID)

#endif /* __MEMPVAR_H__ */
