/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Masaki Muranaka
 *  Copyright (C) 2003 by Monami-software, JAPAN 
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: rendezvous.h,v 1.10 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	ǥ֥ݡȵǽ
 */

#ifndef _RENDEZVOUS_H_
#define _RENDEZVOUS_H_

#include "queue.h"

/*
 *  ǥ֥ݡȽ֥å
 */
typedef struct rendezvous_port_initialization_block {
  ATR	poratr;		/* Rendezvous port attribute. */
  UINT	maxcmsz;	/* ƽФåκ祵(byte count) */
  UINT	maxrmsz;	/* åκ祵(byte count) */
} PORINIB;

/*
 *  ǥ֥ݡȽ֥åϢۥڥ
 */
typedef struct rendezvous_port_initialization_block_apair {
	ID	porid;
	PORINIB	porinib;
} PORINIA;

/*
 *  ǥ֥ݡȴ֥å
 */
typedef struct rendezvous_port_control_block {
  QUEUE	wait_queue;		/* ǥָƽФԤ塼 */
  QUEUE	await_queue;		/* ǥּԤ塼 */
  PORINIB *porinib;		/* ǥ֥ݡȽ֥åؤΥݥ */
  unsigned int	reserved:1;
  unsigned int	exist:2;
} PORCB;


/*
 *  ǥֹ֥å
 */
typedef struct rendezvous_number_control_block {
  QUEUE	wait_queue;		/* ǥֽλԤ塼 */
  RDVNO rdvno;			/* ǥֹ */
} RDVCB;

/*
 *  ǥ֥ݡȵǽν
 */
extern void rendezvous_initialize(void);

#define PORID(porcb)	((ID)((porcb) - porcb_table) + TMIN_PORID)

#endif /* _RENDEZVOUS_H_ */
