/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: semaphore.h,v 1.9 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	ޥեǽ
 */

#ifndef _SEMAPHORE_H_
#define _SEMAPHORE_H_

#include "queue.h"

/*
 *  ޥե֥å
 */
typedef struct semaphore_initialization_block {
	ATR	sematr;		/* ޥե° */
	UINT	isemcnt;	/* ޥեλ񸻿ν */
	UINT	maxsem;		/* ޥեκ񸻿 */
} SEMINIB;

/*
 *  ޥե֥åϢۥڥ
 */
typedef struct semaphore_initialization_block_apair {
	ID	semid;
	SEMINIB	seminib;
} SEMINIA;

/*
 *  ޥե֥å
 */
typedef struct semaphore_control_block {
	QUEUE	wait_queue;	/* ޥեԤ塼 */
	SEMINIB *seminib;	/* ޥե֥åؤΥݥ */
	UINT	semcnt;		/* ޥեߥ */
	unsigned int	exist:2;	/* ȤƤȤTRUE */
	unsigned int	reserved:1;
} SEMCB;

/*
 *  ޥեǽν
 */
extern void	semaphore_initialize(void);

#define SEMID(semcb)	((ID)((semcb) - semcb_table) + TMIN_SEMID)

#endif /* _SEMAPHORE_H_ */
