/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: garbage.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */


// $Header: /cvsroot/toppers-utils/if40/cfg/base/garbage.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $

#include "garbage.h"

#include <typeinfo>
#include <iostream>

using namespace std;

Garbage::Garbage(void)
{
	garbageList().push_front(this);
	mySelf = garbageList().begin();
}

Garbage::~Garbage(void)
{
	if(mySelf != garbageList().end())
		garbageList().erase(mySelf);
	mySelf = garbageList().end();
}

list<Garbage *> & Garbage::garbageList(void)
{
	static list<Garbage *> s_garbageList;
	return s_garbageList;
}

Garbage::iterator Garbage::getTailPosition(void)
{	return garbageList().begin();	}

void Garbage::cleanup(const iterator & end)
{
	iterator scope;
	scope = garbageList().begin();
	while(scope != end && scope != garbageList().end())
	{
		delete (*scope);
		scope = garbageList().begin();
	}
}

void Garbage::finalCleanup(void)
{
	cleanup(garbageList().end());
}


void Garbage::initialize(void)
{
		//ƥå줿֥Ȥ򤳤˴
		//  : initializeϿ줿Garbage֥Ȥ
		//      ư˴оݤˤʤʤ
	iterator scope;

	scope = garbageList().begin();
	while(scope != garbageList().end())
	{
		(*scope)->mySelf = garbageList().end();
		++ scope;
	}

	garbageList().clear();
}

