/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: if40_defs.h,v 1.4 2003/11/10 07:51:15 monaka Exp $
 */

// $Header: /cvsroot/toppers-utils/if40/cfg/if40/if40_defs.h,v 1.4 2003/11/10 07:51:15 monaka Exp $

#ifndef __JSP_DEFS_H
#define __JSP_DEFS_H

#define OBJECTTREE			"object"
#define DYNAMICID			"dynamicid"
#define RESERVEDID			"reservedid"
#define SYSTEM				"system"

#define TASK                "task"
#define SEMAPHORE           "semaphore"
#define EVENTFLAG           "eventflag"
#define DATAQUEUE           "dataqueue"
#define MAILBOX             "mailbox"
#define FIXEDSIZEMEMORYPOOL "mempfix"
#define CYCLICHANDLER       "cyclic"
#define INTERRUPTHANDLER    "interrupt"
#define EXCEPTIONHANDLER    "exception"
#define INITIALIZER         "initializer"
#define TERMINATOR          "terminator"
#define FINALIZER           "finalizer"
#define INCLUDEFILE 		"include"
#define OBJECT_INITIALIZER	"object_initializer"

#define VARSIZEMEMORYPOOL   "mempvar"
#define ALARMHANDLER        "alarm"
#define OVERRUNHANDLER      "overrun"
#define ATTACHED_ISR	    "attached_isr"
#define INTERRUPTSERVICE    "interrupt_service"
#define MESSAGEBUFFER       "messagebuffer"
#define MUTEX               "mutex"
#define RENDEZVOUSPORT      "rendezvous"
#define EXSERVICECALL       "exservicecall"

#define KERNELBUFFER	    "kernelbuffer"

#define KERNEL_CFG			"/file/kernel_cfg"
#define KERNEL_ID			"/file/kernel_id"

#define PREFIX				"/prefix"

#if _MSC_VER
#  define	CMD_PREPROCESSOR "\"C:\\Program Files\\Microsoft Visual Studio\\VC98\\Bin\\cl.exe\" /E /nologo"
#  define   CMD_SYMBOLLISTER "nm.exe"
#  define   CMD_OBJDUMP      "objdump.exe"
#  define   CMD_OBJCOPY      "objcopy.exe"
#  define	CMD_GREP         "grep.exe"
#else
#  define	CMD_PREPROCESSOR "cpp -ansi"
#  define   CMD_SYMBOLLISTER "nm"
#  define   CMD_OBJDUMP      "objdump"
#  define   CMD_OBJCOPY      "objcopy"
#  define	CMD_GREP		 "grep"
#endif


#endif
