/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: jsp_defs.h,v 1.3 2003/11/10 07:51:15 monaka Exp $
 */

// $Header: /cvsroot/toppers-utils/if40/cfg/jsp/jsp_defs.h,v 1.3 2003/11/10 07:51:15 monaka Exp $

#ifndef JSP_DEFS_H
#define JSP_DEFS_H

#define OBJECTTREE			"object"

#define TASK                "task"
#define SEMAPHORE           "semaphore"
#define EVENTFLAG           "eventflag"
#define DATAQUEUE           "dataqueue"
#define MAILBOX             "mailbox"
#define FIXEDSIZEMEMORYPOOL "mempfix"
#define CYCLICHANDLER       "cyclic"
#define INTERRUPTHANDLER    "interrupt"
#define EXCEPTIONHANDLER    "exception"
#define INITIALIZER         "initializer"
#define TERMINATOR          "terminator"
#define INCLUDEFILE 		"include"
#define OBJECT_INITIALIZER	"object_initializer"

#define KERNEL_CFG			"/file/kernel_cfg"
#define KERNEL_ID			"/file/kernel_id"

#define PREFIX				"/prefix"

#endif
