/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: cpu_defs.h,v 1.4 2003/11/18 06:38:26 monaka Exp $
 */

/*
 *  ץå˰¸SH3/4ѡ
 *
 *  Υ󥯥롼ɥեϡkernel.h  sil.h ǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.h  itron.h 󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 */

#ifndef _CPU_DEFS_H_
#define _CPU_DEFS_H_

/*
 *  ץå˰¸
 */
#ifndef _MACRO_ONLY

/*
 * /CPU㳰ϥɥֹη
 */
typedef	UINT		INHNO;		/* ߥϥɥֹ */
typedef	UINT		EXCNO;		/* CPU㳰ϥɥֹ */


/*
 * ߥޥηȳߥޥѹ/
 */
typedef	UINT		IPM;		/* ߥޥ */

extern ER	chg_ipm(IPM ipm)  throw();
extern ER	get_ipm(IPM *p_ipm)  throw();


/*
 *  ߤζػ/
 */
/* extern ER	dis_int(INTNO intno)  throw(); */
/* extern ER	ena_int(INTNO intno)  throw(); */


/*
 *  åȥƥ¸Υӥ
 */
typedef	UD  SYSUTIM;	       /* ǽɾѥƥ */
extern ER   vxget_tim(SYSUTIM *pk_sysutim);


/*
 * ߤγߥޥɽФ
 */
Inline UW
_current_intmask_()
{
    UW sr;

    Asm("stc  sr,%0" : "=r"(sr));
    return(sr & 0x000000f0);
}

/*
 *  Ƥγߤػ
 */
Inline void
_disint_()
{
    UW sr;

    Asm("stc  sr,%0" : "=r"(sr));
    sr = (sr & ~0x000000f0) |  (0xf << 4);
    Asm("ldc %0, sr" : : "r"(sr) );
}

/*
 *  ߥޥ
 */
Inline void
_set_intmask_(UW intmask)
{
    UW sr;
    
    Asm("stc  sr,%0" : "=r"(sr));
    sr = (sr & ~0x000000f0) | intmask;
    Asm("ldc %0, sr" : : "r"(sr) );    
}


/*
 * ߥå֤
 */
#define SIL_PRE_LOC UW _intmask_ = _current_intmask_()
#define SIL_LOC_INT()   _disint_()
#define SIL_UNL_INT()   _set_intmask_(_intmask_)


#endif /* _MACRO_ONLY */
#endif /* _CPU_DEFS_H_ */
