/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id:$
 */
#include <t_services.h>
#include <cstdlib>
#include "kernel_id.h"
#include "diag_exc.h"

struct test
{
		~test() { rot_rdq(TPRI_SELF); }
};

class test_exception {};

void throw_test_exception()
{
	test_exception x;
	throw x;
}

void task(VP_INT exinf)
{
	int tskno = int(exinf);

	for (int i = 0; i < 100; i++)
	{
    try
  	{
  		test t;
  		throw_test_exception();
  		rel_wai(MAIN_TASK);
  	}
  	catch (test_exception&)
  	{
  	}
	}
	set_flg(EVENT_FLAG1, 0x1 << (tskno - 1));
}


/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	serial_ctl_por(TASK_PORTID, (IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV));
	syslog_1(LOG_NOTICE,"Sample task starts (exinf = %d)", exinf);

	act_tsk(TASK1);
	act_tsk(TASK2);

	FLGPTN flgptn;
	if (wai_flg(EVENT_FLAG1, 0x3, TWF_ANDW, &flgptn) == E_OK)
		syslog(LOG_NOTICE, "test succeeded");
  else
		syslog(LOG_NOTICE, "test failed");

	std::exit(0);
}

