/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id:$
 */

// Υƥȥץˤ볰ϡʥꥢݡˤϻ٤
// ꡢ켫ΤưϴԤƤʤ

#include <t_services.h>
#define sys_putc  _kernel_sys_putc
#include <s_services.h>
#include <cstdlib>
#include "kernel_id.h"
#include "diag_tors.h"

void sys_puts(const char* s)
{
	for (char c; (c = *s) != '\0'; s++)
  	sys_putc(c);
}

class test1
{
	int num_;
public:
	test1(int num) : num_(num)
	{
		char s[] = "#0 test1::test1();\n";
		s[1] += num_;
		sys_puts(s);
	}
	test1::~test1()
	{
		char s[] = "#0 test1::~test1();\n";
		s[1] += num_;
		sys_puts(s);
	}
};

test1 t1(1);
test1 t2(2);
test1 t3(3);
test1 t4(4);

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	sys_puts("main_task\n");
	std::exit(0);
}

