/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_tsk.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

/* 
 *  ץץ(1)
 *
 *  JSPͥδŪưǧ뤿Υץץࡥ
 *
 *  ץγ:
 *
 *  桼󥿥եĥᥤ󥿥ʥID: MAIN_TASK
 *  ͥ: MAIN_PRIORITYˤȡĤ¹Ԥ륿ʥID:
 *  TASK1TASK3ͥ: MID_PRIORITYˤǹ롥ޤư
 *  2äμϥɥʼϥɥID: CYCHDR1ˤѤ롥
 *
 *  ¹Ԥ륿ϡtask_loop 롼פ¹Ԥ٤ˡ
 *  ¹Ǥ뤳Ȥ򤢤魯åɽ롥
 *
 *  ϥɥϡĤͥ١HIGH_PRIORITYMID_PRIORITY
 *  LOW_PRIORITYˤΥǥ塼ž롥ץεưľϡ
 *  ϥɥ߾֤ˤʤäƤ롥
 *
 *  ᥤ󥿥ϡꥢI/OݡȤʸϤԤʸϤ
 *  ԤäƤ֤ϡ¹Ԥ륿¹ԤƤˡϤ줿
 *  ʸб¹Ԥ롥Ϥ줿ʸȽδطϼ̤ꡥ
 *  Control-C ޤ 'Q' Ϥȡץλ롥
 *
 *  '1' : ʹߤΥޥɤ TASK1 ФƹԤ
 *  '2' : ʹߤΥޥɤ TASK2 ФƹԤ
 *  '3' : ʹߤΥޥɤ TASK3 ФƹԤ
 *  'a' :  act_tsk ˤ굯ư롥
 *  'A' : Ф뵯ư׵ can_act ˤꥭ󥻥뤹롥
 *  'e' :  ext_tsk ƤӽФλ롥
 *  't' :  ter_tsk ˤ궯λ롥
 *  '>' : ͥ٤ HIGH_PRIORITY ˤ롥
 *  '=' : ͥ٤ MID_PRIORITY ˤ롥
 *  '<' : ͥ٤ LOW_PRIORITY ˤ롥
 *  'G' : ͥ٤ get_pri ɤ߽Ф
 *  's' :  slp_tsk ƤӽФԤˤ롥
 *  'S' :  tslp_tsk(10) ƤӽФԤˤ롥
 *  'w' :  wup_tsk ˤ굯롥
 *  'W' : Ф뵯׵ can_wup ˤꥭ󥻥뤹롥
 *  'l' :  rel_wai ˤ궯ŪԤˤ롥
 *  'u' :  sus_tsk ˤ궯Ԥ֤ˤ롥
 *  'm' : ζԤ֤ rsm_tsk ˤ롥
 *  'M' : ζԤ֤ frsm_tsk ˤ궯롥
 *  'd' :  dly_tsk(10) ƤӽФַвԤˤ롥
 *  'x' : ˥ѥ 0x0001 㳰׵᤹롥
 *  'X' : ˥ѥ 0x0002 㳰׵᤹롥
 *  'y' :  dis_tex ƤӽФ㳰ػߤ롥
 *  'Y' :  ena_tex ƤӽФ㳰Ĥ롥
 *  'r' : Ĥͥ١HIGH_PRIORITYMID_PRIORITYLOW_PRIORITYˤ
 *        ǥ塼ž롥
 *  'c' : ϥɥư롥
 *  'C' : ϥɥߤ롥
 *  'z' : CPU㳰ȯ롥
 *  'Z' : CPUå֤CPU㳰ȯʥץλˡ
 *  'V' : vxget_tim ǽɾѥƥ2ɤࡥ
 *  'v' : ȯԤƥॳɽʥǥեȡˡ
 *  'q' : ȯԤƥॳɽʤ
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_tsk.h"

/*
 *  ¹Լ¹Ԥ륿ؤΥåΰ
 */
char	message[4];

/*
 *  롼ײ
 */
UH	task_loop;		/* ǤΥ롼ײ */
UW	tex_loop;		/* 㳰롼ǤΥ롼ײ */

/*
 *  ¹Լ¹Ԥ륿
 */
void task(VP_INT exinf)
{
	volatile UW	i;
	INT	n = 0;
	INT	tskno = (INT) exinf;
	char	c;

	ena_tex();
	while (1) {
		syslog(LOG_NOTICE, "task%d is running (%03d).", tskno, i++);
		dly_tsk(100 + 30 * tskno);

		if (i == 5) {
			syslog(LOG_NOTICE, "Sample task ends.");
			kernel_exit();
		}
	}
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));
	VB stk[1000];
	INT i;

	/*
 	 *  εư
	 */
	syscall(act_tsk(TASK1));
	syscall(act_tsk(TASK2));
	syscall(act_tsk(TASK3));

	T_CTSK ctsk;
	ctsk.tskatr = TA_HLNG | TA_STA;
	ctsk.exinf = (VP_INT) 10;
	ctsk.task = task;
	ctsk.itskpri = 7;
	ctsk.stksz = 100;
	ctsk.stk = stk;
	syscall(cre_tsk(RESERVED_TASK, &ctsk));

	/*
 	 *  ᥤ롼
	 */
	syscall(slp_tsk());

	syslog(LOG_NOTICE, "Sample task ends.");
	kernel_exit();
}
