/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: alarm.h,v 1.11 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	顼ϥɥ鵡ǽ
 */

#ifndef _ALARM_H_
#define _ALARM_H_

#include "queue.h"
#include "time_event.h"

/*
 *  顼ϥɥ֥å
 */
typedef struct alarm_handler_initialization_block {
	ATR	almatr;		/* 顼ϥɥ° */
	VP_INT	exinf;		/* 顼ϥɥγĥ */
	FP	almhdr;		/* 顼ϥɥεư */
} ALMINIB;

/*
 *  顼ϥɥ֥åϢۥڥ
 */
typedef struct alarm_handler_initialization_block_apair {
	ID	almid;
	ALMINIB	alminib;
} ALMINIA;

/*
 *  顼ϥɥ֥å
 */
typedef struct alarm_handler_control_block {
	QUEUE wait_queue;	/* 顼ϥɥԤ塼 */
	ALMINIB *alminib;
	BOOL	almsta;		/* 顼ϥɥư */
	EVTTIM	evttim;		/* 顼ϥɥư */
	TMEVTB	tmevtb;		/* ।٥ȥ֥å */
	unsigned int	exist:2;	/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} ALMCB;

/*
 *  顼ϥɥ鵡ǽν
 */
extern void	alarm_initialize(void);

#define ALMID(almcb)	((ID)(almcb - almcb_table) + TMIN_ALMID)

#endif /* _ALARM_H_ */
