/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2003 by Monami software, Limited Partnership.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: bufmgr.c,v 1.10 2003/11/12 03:24:42 monaka Exp $
 */

/*
 *  ͥХåեޥ͡
 */
#include "jsp_kernel.h"
#include "bufmgr.h"

extern VP *__kernel_bufmgr_buffer;
extern SIZE __kernel_bufmgr_buffer_size;

extern KMEMB *__kernel_bufmgr_kmemb;

/*
 *  ͥХåեޥ͡ν
 */
#ifdef __bufmgrini

KMEMB *__kernel_bufmgr_kmemb;

void
bufmgr_initialize()
{
  kmem_setup((VP)&__kernel_bufmgr_buffer, __kernel_bufmgr_buffer_size, &__kernel_bufmgr_kmemb);
}

#endif /* __bufmgrini */

/*
 *  ͥХåեγ
 *
 */
#ifdef __bufmgrrelease

BOOL
bufmgr_release(VP ptr)
{
	BOOL ret;
	UB *buf;

	buf = (UB *)&__kernel_bufmgr_buffer;

	/*
	 *  ⤷ͥХåեΰǤʤäȤ顢
	 *  bufmgr_allocateǼΤǤϤʤȤˤʤΤǡ
	 *  ⤻TRUE֤
	 */
	if (buf <= (UB *)ptr && (UB *)ptr < (buf + __kernel_bufmgr_buffer_size)) {
		ret = kmem_release(__kernel_bufmgr_kmemb, ptr);

		return ret;
	}

	return (ptr != 0);
}

#endif /* __bufmgrrelease */
	
