/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: interrupt.h,v 1.10 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	ߴǽ
 */

#ifndef _INTERRUPT_H_
#define _INTERRUPT_H_

#include "queue.h"

/*
 *  ߥϥɥ֥å
 */
typedef struct interrupt_handler_initialization_block {
	INHNO	inhno;		/* ߥϥɥֹ */
	ATR	inhatr;		/* ߥϥɥ° */
	FP	inthdr;		/* ߥϥɥεư */
} INHINIB;

/*
 *  ߥӥ롼֥å
 */
typedef struct interrupt_service_rourine_initialization_block {
	ATR	isratr;		/* ߥӥ롼° */
	VP_INT	exinf;		/* ߥӥ롼γĥ */
	INTNO	intno;		/* ߥӥ롼ղäֹ */
	FP	isr;		/* ߥӥ롼εư */
} ISRINIB;

/*
 *  ߥӥ롼֥åϢۥڥ
 */
typedef struct interrupt_service_rourine_initialization_block_apair {
	ID	isrid;
	ISRINIB	isrinib;
} ISRINIA;

/*
 *  ߥӥ롼֥å
 */
typedef struct interrupt_service_control_block {
	QUEUE	wait_queue;	/* ޥեԤ塼 */
	ISRINIB *isrinib;	/* ߥӥ롼֥åؤΥݥ */
	unsigned int	exist:2;	/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} ISRCB;

/*
 *  ߴǽν
 */
extern void	interrupt_initialize(void);

#define ISRID(isrcb)	((ID)((isrcb) - isrcb_table) + TMIN_ISRID)

#endif /* _INTERRUPT_H_ */
