/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: syslog.h,v 1.3 2003/11/10 07:51:21 monaka Exp $
 */

/*
 *	ƥǽ
 */

#ifndef _SYSLOG_H_
#define _SYSLOG_H_

#include <t_syslog.h>

/*
 *  ХåեȤ˥뤿Υݥ
 */
#ifndef TCNT_SYSLOG_BUFFER
#define TCNT_SYSLOG_BUFFER	32	/* ХåեΥ */
#endif /* TCNT_SYSLOG_BUFFER */

extern SYSLOG	syslog_buffer[];	/* Хåե */
extern UINT	syslog_count;		/* ХåեΥο */
extern UINT	syslog_head;		/* ƬΥγǼ */
extern UINT	syslog_tail;		/* ΥγǼ */
extern UINT	syslog_lost;		/* 줿ο */

/*
 *  Ϥ٤ν١ʥӥåȥޥåס
 */
extern UINT	syslog_logmask;		/* Хåե˵Ͽ٤ */
extern UINT	syslog_lowmask;		/* ٥Ϥ٤ */

#ifndef OMIT_SYSLOG

/*
 *  ƥǽν
 */
extern void	syslog_initialize(void);

/*
 *  ƥǽνλ
 */
extern void	syslog_terminate(void);

#else /* OMIT_SYSLOG */

#define syslog_initialize()	((void) 0)
#define syslog_terminate()	((void) 0)

#endif /* OMIT_SYSLOG */
#endif /* _SYSLOG_H_ */
